Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Auto_IncDec Class Template Reference

This class automatically increments and decrements a parameterized counter. More...

`#include <Auto_IncDec_T.h>`

Collaboration diagram for ACE_Auto_IncDec:

[legend]
List of all members.

## Public Methods
| ACE_Auto_IncDec (ACE_SAFELY_INCREMENTABLE_DECREMENTABLE &counter)
| Implicitly increment the counter. More...
| ~ACE_Auto_IncDec (void)
| Implicitly decrement the counter. More...
void | dump (void) const
| Dump the state of an object. More...
## Protected Attributes
ACE_SAFELY_INCREMENTABLE_DECREMENTABLE & | counter_
| Reference to the <ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> counter we're incrementing/decrementing. More...
## Private Methods
void | operator= (const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE > &)
| ACE_Auto_IncDec (const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE > &)

## Detailed Description

### template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
class ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >

This class automatically increments and decrements a parameterized counter.

This data structure is meant to be used within a method, function, or scope. The actual parameter given for the <ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> template parameter must provide at least opertaors ++ and --.

## Constructor & Destructor Documentation

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_INLINE ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::ACE_Auto_IncDec | ( | ACE_SAFELY_INCREMENTABLE_DECREMENTABLE & | counter | ) |

| Implicitly increment the counter.

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_INLINE ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::~ACE_Auto_IncDec | ( | void |  | ) |

| Implicitly decrement the counter.

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::ACE_Auto_IncDec | ( | const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE > & |  | ) | `[private]`

## Member Function Documentation

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
void ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::dump | ( | void |  | ) | const

| Dump the state of an object.

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
void ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::operator= | ( | const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE > & |  | ) | `[private]`

## Member Data Documentation

template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_SAFELY_INCREMENTABLE_DECREMENTABLE& ACE_Auto_IncDec::counter_`[protected]`

| Reference to the <ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> counter we're incrementing/decrementing.

The documentation for this class was generated from the following files:

- Auto_IncDec_T.h
- Auto_IncDec_T.cpp
- Auto_IncDec_T.i